const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const payments = sequelize.define(
    'payments',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

payment_type: {
        type: DataTypes.ENUM,
      
      

        values: [

"escrow_deposit",


"milestone_release",


"refund",


"payout"

        ],

      },

amount_gross: {
        type: DataTypes.DECIMAL,
      
      

      },

platform_fee_client_rate: {
        type: DataTypes.DECIMAL,
      
      

      },

platform_fee_freelancer_rate: {
        type: DataTypes.DECIMAL,
      
      

      },

platform_fee_amount: {
        type: DataTypes.DECIMAL,
      
      

      },

amount_net: {
        type: DataTypes.DECIMAL,
      
      

      },

status: {
        type: DataTypes.ENUM,
      
      

        values: [

"pending",


"paid",


"failed",


"refunded"

        ],

      },

provider: {
        type: DataTypes.ENUM,
      
      

        values: [

"simulated",


"stripe",


"paypal"

        ],

      },

provider_reference: {
        type: DataTypes.TEXT,
      
      

      },

initiated_at: {
        type: DataTypes.DATE,
      
      

      },

paid_at: {
        type: DataTypes.DATE,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  payments.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity




















    db.payments.hasMany(db.invoices, {
      as: 'invoices_payment',
      foreignKey: {
          name: 'paymentId',
      },
      constraints: false,
    });









//end loop



    db.payments.belongsTo(db.contracts, {
      as: 'contract',
      foreignKey: {
        name: 'contractId',
      },
      constraints: false,
    });

    db.payments.belongsTo(db.users, {
      as: 'payer',
      foreignKey: {
        name: 'payerId',
      },
      constraints: false,
    });

    db.payments.belongsTo(db.users, {
      as: 'payee',
      foreignKey: {
        name: 'payeeId',
      },
      constraints: false,
    });




    db.payments.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.payments.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return payments;
};


